// TTY-Grin
// Copyright (C) 2001-2003 Daniel Beer
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

struct kbd_domain_init {
  int key;
  const char *command;
};

kbd_domain_init kbd_default_default[]={
  {SL_KEY_UP,    "up"},
  {SL_KEY_DOWN,  "down"},
  {SL_KEY_PPAGE, "page-up"},
  {SL_KEY_NPAGE, "page-down"},
  {SL_KEY_HOME,  "jump-top"},
  {SL_KEY_END,   "jump-end"},
  {12,           "redraw"},
  {'q',          "quit"},
  {'/',          "find-forward"},
  {';',          "find-back"},
  {'?',          "help"},
  {'\r',         "select"},
  {'\n',         "select"},
  {' ',          "select"},
  {0, 0}
};

kbd_domain_init kbd_default_tree[]={
  {'[', "collapse-all"},
  {']', "expand-all"},
  {'-', "collapse"},
  {'+', "expand"},
  {0, 0}
};

kbd_domain_init kbd_default_addresses[]={
  {'k', "modify-key"},
  {'c', "modify-comment"},
  {'a', "modify-address"},
  {'n', "new-address"},
  {'b', "new-book"},
  {'d', "delete"},
  {'r', "rename"},
  {0, 0}
};

kbd_domain_init kbd_default_boxlist[]={
  {'c', "create"},
  {'d', "delete"},
  {'r', "rename"},
  {0, 0}
};

kbd_domain_init kbd_default_compose[]={
  {'!', "pick-address to"},
  {'@', "pick-address cc"},
  {'#', "pick-address bcc"},
  {'1', "modify to"},
  {'2', "modify cc"},
  {'3', "modify bcc"},
  {'4', "modify newsgroups"},
  {'5', "modify subject"},
  {'6', "modify references"},
  {'a', "attach"},
  {'d', "delete"},
  {'e', "edit"},
  {'p', "postpone"},
  {'s', "send"},
  {'g', "pgp-toggle"},
  {'r', "preview"},
  {0, 0}
};

kbd_domain_init kbd_default_imap4[]={
  {'h', "modify-hostname"},
  {'u', "modify-user"},
  {'r', "modify-prefix"},
  {'p', "modify-password"},
  {'n', "create"},
  {'d', "delete"},
  {0, 0}
};

kbd_domain_init kbd_default_mailbox[]={
  {'r', "toggle-read"},
  {'m', "toggle-marked"},
  {'d', "toggle-deleted"},
  {0, 0}
};

kbd_domain_init kbd_default_menu[]={
  {'i', "inbox"},
  {'m', "mail"},
  {'n', "news"},
  {'p', "imap4"},
  {'c', "compose"},
  {'a', "addresses"},
  {'r', "resume"},
  {0, 0}
};

kbd_domain_init kbd_default_message[]={
  {',', "prev-part"},
  {'.', "next-part"},
  {'g', "go-to-line"},
  {'a', "attachments"},
  {'f', "forward"},
  {'w', "toggle-raw"},
  {'r', "reply"},
  {'s', "save"},
  {'m', "move"},
  {'e', "export"},
  {'d', "delete"},
  {0, 0}
};

kbd_domain_init kbd_default_news[]={
  {'p', "post"},
  {'d', "delete"},
  {'s', "new-server"},
  {'g', "new-group"},
  {'b', "pick-group"},
  {0, 0}
};

kbd_domain_init kbd_default_newsgroup[]={
  {'r', "toggle-read"},
  {'m', "toggle-marked"},
  {'d', "toggle-deleted"},
  {'a', "mark-all-read"},
  {'p', "post"},
  {0, 0}
};

kbd_domain_init kbd_default_read_line[]={
  {7,            "cancel"},
  {8,            "delete-back"},
  {127,          "delete-back"},
  {4,            "delete-forward"},
  {SL_KEY_LEFT,  "back"},
  {SL_KEY_RIGHT, "forward"},
  {1,            "jump-top"},
  {5,            "jump-end"},
  {11,           "cut-forward"},
  {21,           "cut-back"},
  {9,            "complete"},
  {0, 0}
};

struct {
  const char *name;
  kbd_domain_init *bindings;
} kbd_default[]={
  {"default",   kbd_default_default},
  {"tree",      kbd_default_tree},
  {"addresses", kbd_default_addresses},
  {"boxlist",   kbd_default_boxlist},
  {"compose",   kbd_default_compose},
  {"imap4",     kbd_default_imap4},
  {"mailbox",   kbd_default_mailbox},
  {"menu",      kbd_default_menu},
  {"message",   kbd_default_message},
  {"news",      kbd_default_news},
  {"newsgroup", kbd_default_newsgroup},
  {"read-line", kbd_default_read_line},
  {0, 0}
};
